# Название чейнкода: transactionCC
    Канал: transactionchannel
    Версия: 1

## Описание чейнкода
В этом чейнкоде происходит основной процесс со средствами пользователей

## Функции
	ping                                    // Проверка установки чейнкода и возможности записи в леджер
	lockFundsOnAccount                      // Блокировка средств для проведения транзакции
	lockOutFundsOnAccount                   // Вывод средств. Блокировка средств на вывод из системы
	lockTransferToMarket                    // Вывод средств на биржу. Блокировка средств на перевод средств на биржу на MARKET_USER
	loadMarketFounds                        // Ввод средств с биржи в Cryptoenter Engine
	checkExistsTransactionByList            // Проверка списка на транзакций на существования в канале transactionchannel по operationID
	accountCurrencyBalance                  // Проверка баланса на счету
	transferFunds                           // Транзакция между пользователями разблокировки средств
    unlockFundsOnAccount                    // Разблокировки средств на исходый счет пользователя
	outTransferFunds                        // Транзакция заблокированных денег на вывод. перевод средств на END_USER
	depositFunds                            // Ввод средств. Подгрузка введеных средств из канала cryptocurrencychannel в канал transactionchannel
	getUsersTransaction                     // Получение всех транзакций по пользователю
	findLockAmountByOperationIdAndUserIdAndCurrencyType    // Получение заблокированных средств по operationID и Пользователю

## Вызов зависимых чейнкодов

#### GetUser - получение информации по пользователю
	GetUserChaincode = "userCC"
	GetUserFunction  = "getUser"
	GetUserChannel   = "userchannel"

#### CheckAndLoadAccount - проверка и подгрузка данных по счету
	CheckAndLoadAccountChaincode = "accountCC"
	CheckAndLoadAccountFunction  = "checkAndLoadAccount"
	CheckAndLoadAccountChannel   = "accountchannel"

#### OfferIsApproved - проверить является ли заявка принятой
	OfferIsApprovedChaincode = "offerCC"
	OfferIsApprovedFunction  = "isOfferApproved"
	OfferIsApprovedChannel   = "offerchannel"

#### GetCryptocurrenciesByDaemonName - получание выписки по счету по имени демона
	GetCryptocurrenciesByDaemonNameChaincode = "cryptocurrencyCC"
	GetCryptocurrenciesByDaemonNameFunction  = "getCryptocurrenciesByDaemonName"
	GetCryptocurrenciesByDaemonNameChannel   = "cryptocurrencychannel"

#### GetIntAccountByExtAccount - получение внутреннего счета по внешнему счету
	GetIntAccountByExtAccountChaincode = "userpreferenceCC"
	GetIntAccountByExtAccountFunction  = "getIntAccountByExtAccount"
	GetIntAccountByExtAccountChannel   = "userpreferencechannel"

#### GetOrganization - получение информации об организации
	GetOrganizationChaincode = "organizationCC"
	GetOrganizationFunction  = "getOrganization"
	GetOrganizationChannel   = "organizationchannel"
	
## Зависимости между чейнкодами

#### lockFundsOnAccount - Блокировка средств для проведения транзакции
	- CheckAndLoadAccount
	- GetUser
	- GetOrganization
	- GetCommission
	
#### lockOutFundsOnAccount - Блокировка средств на вывод из системы
	- CheckAndLoadAccount
	- GetUser
	- GetOrganization
	- GetCommission
	
#### checkExistsTransactionByList - Проверка списка на транзакций на существования в канале transactionchannel по operationID
	- нет
	
#### accountCurrencyBalance - Проверка баланса на счету
	- нет
	
#### transferFunds - Транзакция между пользователями разблокировки средств
	- OfferIsApproved
	- CheckAndLoadAccount
	- GetUser
	- GetOrganization
	- GetCommission
	
#### outTransferFunds - Транзакция заблокированных денег на вывод. перевод средств на END_USER
	- CheckAndLoadAccount
	- GetUser
	- GetOrganization
	- GetCommission
	-
	
#### depositFunds - Подгрузка введеных средств из канала cryptocurrencychannel в канал transactionchannel
	- GetCryptocurrenciesByDaemonName
	
#### getUsersTransaction - Получение всех транзакций по пользователю
	- нет
	
#### findLockAmountByOperationIdAndUserIdAndCurrencyType - Получение заблокированных средств по operationID и Пользователю
	- нет
	
## Открытые вопросы

#### accountCurrencyBalance - Проверка баланса на счету
    - нужно добавить проверку на существование переданного accountId в чейнкоде accountCC?
    
#### transferFunds - Транзакция между пользователями разблокировки средств
    - убрать из параметров информацию о заблокированных транзакциях
    - добавить в параметры operationId
    - найти все транзакции для заблокированных средств по operationId и operationType (LockAmount, LockCommission)
    - по этим транзакциям выполнить переводы