package main

import (
	"gitlab.smartblocklab.com/smartcontracts/common/chaincode"
	"gitlab.smartblocklab.com/smartcontracts/common/invoke"
	"gitlab.smartblocklab.com/smartcontracts/transactionCC/function"
)

func NewChaincode() *chaincode.CommonChaincode {
	// TODO: WIP
	// добавить валидацию типов процессов и операций для методов
	// например если я буду выполнять метод для вывода средств а укажу тип процесса обмен
	// или если тип операции будет блокировка комиссии, а у транзакции будет указано что это перевод пользователю
	// продумать этот механизм
	// TODO solved: решается проверкой типа и выброом error

	// invoke

	chaincode.ChaincodeVar.Actions[invoke.LockFundsOnAccountFunction] = function.LockFundsOnAccount       // Блокировка средств для проведения транзакции
	chaincode.ChaincodeVar.Actions[invoke.LockOutFundsOnAccountFunction] = function.LockOutFundsOnAccount // Блокировка средств на вывод из системы на END_USER
	chaincode.ChaincodeVar.Actions[invoke.TransferFundsFunction] = function.TransferFunds                 // Транзакция между пользователями разблокировки средств
	chaincode.ChaincodeVar.Actions[invoke.TransferFunction] = function.Transfer                           // Перевод средств от одного пользователя другому одним методом
	chaincode.ChaincodeVar.Actions[invoke.UnlockFundsOnAccountFunction] = function.UnlockFundsOnAccount   // Разблокировки средств на исходый счет пользователя

	chaincode.ChaincodeVar.Actions[invoke.DepositFundsFunction] = function.DepositFunds    // Подгрузка введеных средств из канала cryptocurrencychannel в канал transactionchannel

	chaincode.ChaincodeVar.Actions[invoke.DepositBtcFundsFunction] = function.DepositBtcFunds // Ввод биткойноподобных средств на биржу
	chaincode.ChaincodeVar.Actions[invoke.DepositEthFundsFunction] = function.DepositEthFunds // Ввод эфироподобных средств на биржу

	chaincode.ChaincodeVar.Actions[invoke.LockTransferToMarketFunction] = function.LockTransferToMarket // Блокировка средств на перевод средств на биржу на MARKET_USER
	chaincode.ChaincodeVar.Actions[invoke.LoadMarketFoundsFunction] = function.LoadMarketFounds         // Ввод средств на биржу


	chaincode.ChaincodeVar.Actions[invoke.WithdrawalMarketFundsFunction] = function.WithdrawalMarketFounds // Вывод средств с биржи

	// query

	chaincode.ChaincodeVar.Actions[invoke.CheckExistsTransactionByListFunction] = function.CheckExistsTransactionByList                                               // Проверка списка на транзакций на существования в канале transactionchannel по operationID
	chaincode.ChaincodeVar.Actions[invoke.GetTransactionsFunction] = function.GetTransactions                                                                         // Получение всех транзакций по пользователю
	chaincode.ChaincodeVar.Actions[invoke.FindLockAmountByOperationIdAndUserIdAndCurrencyTypeFunction] = function.FindLockAmountByOperationIdAndUserIdAndCurrencyType // Получение заблокированных средств по operationID
	chaincode.ChaincodeVar.Actions[invoke.AccountCurrencyBalanceFunction] = function.AccountCurrencyBalance                                                           // Проверка баланса на счету

	chaincode.ChaincodeVar.Actions[invoke.ClearLedger] = function.ClearLedger

	return &chaincode.ChaincodeVar
}
