package function

import (
	"encoding/json"
	"github.com/pkg/errors"
	"gitlab.smartblocklab.com/smartcontracts/common/model/transactionCC"
	"gitlab.smartblocklab.com/smartcontracts/transactionCC/mngr"
	"gitlab.smartblocklab.com/smartcontracts/common/model/requests"
	"gitlab.smartblocklab.com/smartcontracts/common/chaincode"
)

func FindLockAmountByOperationIdAndUserIdAndCurrencyType(userParameter *requests.Parameter, systemParameter *requests.Parameter, manager chaincode.IManager) (interface{}, error) {
	var findLockAmountByOperationIDAndUserIdArg transactionCC.FindLockAmountByOperationIdAndUserIdAndCurrencyTypeArg
	err := json.Unmarshal(systemParameter.Param, &findLockAmountByOperationIDAndUserIdArg)
	if err != nil {
		return nil, errors.Errorf("Invalid format, failed due to %s", err)
	}

	return mngr.GetTransactionManager(manager).FindLockAmountByOperationIdAndUserIdAndCurrencyType(findLockAmountByOperationIDAndUserIdArg)
}
