package function

import (
	"encoding/json"
	"gitlab.smartblocklab.com/smartcontracts/common/chaincode"

	"gitlab.smartblocklab.com/smartcontracts/common/invoke"
	"github.com/pkg/errors"
	"gitlab.smartblocklab.com/smartcontracts/common/model/transactionCC"
	"gitlab.smartblocklab.com/smartcontracts/transactionCC/mngr"
	"gitlab.smartblocklab.com/smartcontracts/common/model/requests"
)

func LockOutFundsOnAccount(userParameter *requests.Parameter, systemParameter *requests.Parameter, manager chaincode.IManager) (interface{}, error) {
	var txn transactionCC.OutTxnFundsLockInput
	err := json.Unmarshal(userParameter.Param, &txn)
	if err != nil {
		return nil, errors.Errorf("Invalid format, failed due to %s", err)
	}

	if txn.OutUser.UserID != userParameter.UserID {
		return nil, errors.Errorf("Can't %s because signer UserID %s not equals with locked founds UserID %s", invoke.LockOutFundsOnAccountFunction, userParameter.UserID, txn.OutUser.UserID)
	}

	var lockFundsOnAccountArg transactionCC.LockFundsOnAccountArg
	err = json.Unmarshal(systemParameter.Param, &lockFundsOnAccountArg)
	if err != nil {
		return nil, errors.Errorf("Can't unmarshal systemParams to LockFundsOnAccountArg. Error %s", err)
	}

	txn.OperationID = lockFundsOnAccountArg.OperationID

	return mngr.GetTransactionManager(manager).LockOutFundsOnAccount(&txn)
}
