package mngr

import (
	"github.com/pkg/errors"
	"gitlab.smartblocklab.com/smartcontracts/common/model/marketCC"
	"gitlab.smartblocklab.com/smartcontracts/common/model/transactionCC"
)

func (this *TransactionManagerImpl) WithdrawalMarketFounds(findLockAmountByOperationIDAndUserIdArg transactionCC.FindLockAmountByOperationIdAndUserIdAndCurrencyTypeArg) error {
	// смотрим в канал биржи все заявки для перевода
	// по найденным заявкам проверяем был ли уже перевод
	// если перевода небыло создаем транзакцию на пополнения баланка пользователю "вывод средств средства"

	operationID := "op"
	arg := marketCC.FindTransactionsByOperationIDArg{
		OperationID: operationID,
	}
	transactionList, err := this.MarketCC.FindTransactionsByOperationID(arg)
	if err != nil {
		return errors.Errorf("Locked market by operationId need to be only one")
	}

	if len(transactionList.MarketTransactions) != 2 {
		return errors.Errorf("Locked market by operationId need to be only tow, one IN and one OUT")
	}

	marketTransaction := transactionList.MarketTransactions[0]
	if marketTransaction.OperationID != operationID {
		return errors.Errorf("Locked market operationID '%s' for transacton not equals with searched operationID '%s'", marketTransaction.OperationID, operationID)
	}

	// TODO
	// поиск и проверка транзакции на IN
	// поиск и проверка транзакции на OUT

	// если всё хорошо, тогда создаем транзакцию для перевода с "системного пользователя биржи для вывода средств" на "внутреннего пользователя, который запрашивал вывод средств"

	// счет в transactionCC мы бирем из аргументов вызова этой функции
	// или как другой вариант делать сначало заявку на перевод, в заявке указывать account биржи/account внутренний и потом делать перевод

	//if marketTransaction.DestinationUserAccountInfo != nil {
	//	return errors.Errorf("Locked market operationID '%s' for transacton not equals with searched operationID '%s'", marketTransaction.OperationID, operationID)
	//}

	if marketTransaction.DestinationUserAccountInfo != nil {
		return errors.Errorf("Locked market operationID '%s' for transacton not equals with searched operationID '%s'", marketTransaction.OperationID, operationID)
	}

	if marketTransaction.UserAccountInfo != nil {
		return errors.Errorf("Locked market operationID '%s' for transacton not equals with searched operationID '%s'", marketTransaction.OperationID, operationID)
	}

	if marketTransaction.OperationType != "" {
		return errors.Errorf("Locked market operationID '%s' for transacton not equals with searched operationID '%s'", marketTransaction.OperationID, operationID)
	}

	if marketTransaction.DocumentType != "" {
		return errors.Errorf("Locked market operationID '%s' for transacton not equals with searched operationID '%s'", marketTransaction.OperationID, operationID)
	}

	return nil
}
