package chaincode

import (
	"errors"
)

type PingRecord struct {
	Keys  []string `json:"keys,omitempty"`
	Value string `json:"value,omitempty"`
}

func (this PingRecord) GetObjectType() string  {
	return "PingRecord";
}

func (this PingRecord) CheckBeforeAdd(manager IManager) error {
	return nil
}

func (this PingRecord) New() ValidObject {
	return &PingRecord{}
}

func (this PingRecord) CheckBeforeUpdate(updatedObject ValidObject, manager IManager) error {
	return errors.New("METHOD_DOES_NOT_IMPLEMENT")
}

func (this PingRecord) GetKey(manager IManager) []string {
	return append(this.Keys, manager.GetTxID())
}

func (this PingRecord) Validate() error {
	if len(this.Keys) == 0 {
		return errors.New("Key is empty")
	}

	return nil
}
