package icode

import (
	"gitlab.smartblocklab.com/smartcontracts/common/model/requests"
	"gitlab.smartblocklab.com/smartcontracts/common/model/keyValueCC"
	"gitlab.smartblocklab.com/smartcontracts/common/nums"
	"gitlab.smartblocklab.com/smartcontracts/common/model/codeCC"
)

type ICodeManager interface {
	// invoke
	AddCode(userId string, currencyNumber *nums.PlainCurrencyNumber, depositEthInfo *codeCC.CodeInfo) (*keyValueCC.KeyValue, error)

	AddKeyValue(keyValue *keyValueCC.KeyValue) (*keyValueCC.KeyValue, error)
	AddKeyValueArray(keyValueArray *keyValueCC.KeyValueArray) (*keyValueCC.KeyValueArray, error)
	// query
	GetKeyValue(keyId *requests.Id) (*keyValueCC.KeyValue, error)
	GetKeyValueArray(keyArrayId *requests.ArrayId) (*keyValueCC.KeyValueArray, error)
	GetKeyValueArrayByKeysWithFilter(keysWithFilter *requests.KeysWithFilter) (*keyValueCC.KeyValueArray, error)
}
