package imarket

import (
	"gitlab.smartblocklab.com/smartcontracts/common/model/marketCC"
	"gitlab.smartblocklab.com/smartcontracts/common/model/requests"
)

type IMarketManager interface {
	DepositFunds(userID string, inputMarketFoundsObject marketCC.UIDepositFunds, operationID requests.Id) (*marketCC.MarketTransaction, error)
	GetBalance(balanceArg marketCC.MarketArg) (*marketCC.MarketBalance, error)
	LockWithdrawalFunds(userID string, arg marketCC.UIMarketWithdrawal, operationID requests.Id) (*marketCC.MarketTransactionList, error)
	TransferWithdrawalFunds(userID string, operationID requests.Id) (*marketCC.MarketTransactionList, error)
	CreateOrder(userID string, marketOrder marketCC.UIMarketOrder, operationID requests.Id) (*marketCC.MarketTransactionList, error)
	GetAllOrders() (*marketCC.PlainMarketOrderList, error)
	GetUserOrders(arg requests.Id) (*marketCC.PlainMarketOrderList, error)
	CancelOrder(userID string, id requests.Id) (*marketCC.MarketTransactionList, error)
	MatchOrders() (*marketCC.TransactionList, error)
	FindOutgoingTransactions(arg marketCC.FindMarketTransactionArg) (*marketCC.MarketTransactionList, error)
	FindTransactionsByOperationID(arg marketCC.FindTransactionsByOperationIDArg) (*marketCC.MarketTransactionList, error)
	FindIncomingTransactions(arg marketCC.FindMarketTransactionArg) (*marketCC.MarketTransactionList, error)
}
