package codeCC

import (
	"encoding/json"
	"errors"
	"gitlab.smartblocklab.com/smartcontracts/common/chaincode"
)

type CodeInfo struct {
	CodeAmount string `json:"code_amount"`
	Wallet     string `json:"wallet"`
}

func Unmarshal(data []byte) (*CodeInfo, error) {
	if data == nil {
		return nil, chaincode.GlobalLogger.Error("can't Unmarshal nil data")
	}

	var obj CodeInfo
	err := json.Unmarshal(data, &obj)
	return &obj, err;
}

func Marshal(depositEthInfo CodeInfo) ([]byte, error) {
	return json.Marshal(depositEthInfo);
}

func (this *CodeInfo) Validate() error {
	if this == nil {
		return errors.New("depositEthInfo can't be nil")
	}

	if len(this.CodeAmount) == 0 {
		return errors.New("code can't be nil")
	}

	if len(this.Wallet) == 0 {
		return errors.New("wallet can't be nil")
	}

	return nil
}
