package marketCC

import (
	"gitlab.smartblocklab.com/smartcontracts/common/model/transactionCC"
	"github.com/pkg/errors"
	"gitlab.smartblocklab.com/smartcontracts/common/chaincode"
)

type MarketTransaction struct {
	SessionID    SessionID    `json:"session_id"` // can be 0 or not defined for marketTransaction new
	DocumentType DocumentType `json:"document_type"`
	*transactionCC.TransactionRecord
}

func (this MarketTransaction) GetObjectType() string  {
	return "MarketTransaction";
}

func (this MarketTransaction) New() chaincode.ValidObject {
	return &MarketTransaction{}
}

func (record MarketTransaction) Validate() error {
	err := record.TransactionRecord.Validate()
	if err != nil {
		return err
	}

	if len(record.DocumentType) == 0 {
		return errors.New("can't save market record with empty document type")
	}

	return nil
}
