package nums

import "gitlab.smartblocklab.com/smartcontracts/common/logging"

var btc, _ = NewAsset("BTC", 8, "21000000", "0.00000001")
var eth, _ = NewAsset("ETH", 18, "-1", "0.000000000000000001")
var xrp, _ = NewAsset("XRP", 8, "38622870411", "0.000001")
var bch, _ = NewAsset("BCH", 8, "21000000", "0.00000001")
var xem, _ = NewAsset("XEM", 7, "8999999999", "0.000001")
var ltc, _ = NewAsset("LTC", 8, "84000000", "0.00000001")
var dash, _ = NewAsset("DASH", 8, "18000000", "0.00000001")
var miota, _ = NewAsset("MIOTA", 0, "2777530283277760", "1")
var etc, _ = NewAsset("ETC", 18, "97261398", "0.000000000000000001")
var neo, _ = NewAsset("NEO", 18, "100000000", "0.000000000000000001")
var qtum, _ = NewAsset("QTUM", 18, "100000000", "0.000000000000000001")
var xmr, _ = NewAsset("XMR", 12, "18400000", "0.000000000001")
var strat, _ = NewAsset("STRAT", 15, "98502820", "0.000000000000001")
var bcc, _ = NewAsset("BCC", 8, "28000000", "0.00000001")
var waves, _ = NewAsset("WAVES", 8, "100000000", "0.00000001")
var zec, _ = NewAsset("ZEC", 8, "21000000", "0.00000001")
var btg, _ = NewAsset("BTG", 8, "21000000", "0.00000001")
var doge, _ = NewAsset("DOGE", 8, "21000000", "0.00000001")
var emc2, _ = NewAsset("EMC2", 8, "21000000", "0.00000001")

// TODO use channel for this
func CurrencyTypeFrom(currencyType string) (*Asset, error) {
	if len(currencyType) == 0 {
		return nil, logging.Get().Error("failed. currency type can't be empty")
	}

	switch currencyType {
	case "BTC":
		return btc, nil
	case "ETH":
		return eth, nil
	case "XRP":
		return xrp, nil
	case "BCH":
		return bch, nil
	case "XEM":
		return xem, nil
	case "LTC":
		return ltc, nil
	case "DASH":
		return dash, nil
	case "MIOTA":
		return miota, nil
	case "ETC":
		return etc, nil
	case "NEO":
		return neo, nil
	case "QTUM":
		return qtum, nil
	case "XMR":
		return xmr, nil
	case "STRAT":
		return strat, nil
	case "BCC":
		return bcc, nil
	case "WAVES":
		return waves, nil
	case "ZEC":
		return zec, nil
	case "BTG":
		return btg, nil
	case "DOGE":
		return doge, nil
	case "EMC2":
		return emc2, nil
	default:
		return nil, logging.Get().Errorf("failed. Bad currencyType %s", currencyType)
	}
}
