package nums

import (
	"github.com/shopspring/decimal"
	"gitlab.smartblocklab.com/smartcontracts/common/chaincode"
	"encoding/json"
)

type CurrencyNumber struct {
	Num   decimal.Decimal `json:"num,omitempty"`
	Asset *Asset          `json:"asset,omitempty"`
}

// Описатель валюты
type Asset struct {
	CurrencyType string          `json:"currency_type,omitempty"`
	Scale        uint            `json:"base,omitempty"` // Точность вычислений после запятой, нужна, так как работаем с интами. пишется как  100000
	MaxValue     decimal.Decimal `json:"max_value,omitempty"`
	MinValue     decimal.Decimal `json:"min_value,omitempty"`
}

type PlainCurrencyNumber struct {
	Amount       string `json:"amount,omitempty"`
	CurrencyType string `json:"currency_type,omitempty"`
}

func Unmarshal(data []byte) (*PlainCurrencyNumber, error) {
	if data == nil {
		return nil, chaincode.GlobalLogger.Error("can't Unmarshal nil data")
	}

	var obj PlainCurrencyNumber
	err := json.Unmarshal(data, &obj)
	return &obj, err;
}