package actions

import "gitlab.smartblocklab.com/smartcontracts/common/invoke"

// common method

const ping = "ping"
const clearLedger = "clearLedger"
const configure = "configure"

var SecurityPreferenceArray = []SecurityPreference{
	// Common
	// invoke

	// ping
	SecurityPreference{invoke.AccountCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.MarketaccountCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AuthCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.CommissionCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OfferCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.TransactionCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OrganizationCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserPreferenceCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.SystemPreferenceCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.DevicePreferenceCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.SessionCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.ProcessTypeCurrencyCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycUserCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycRuleCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycDocumentCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycDocumentStatusCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycRuleStatusCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumInputCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OfferStatusCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OfferPropertiesCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	SecurityPreference{invoke.BitcoinAccountOfferCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.BitcoinAccountOfferPropertiesCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.BitcoinAccountOfferStatusCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	SecurityPreference{invoke.BitcoinWithdrawalOfferCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.BitcoinWithdrawalOfferPropertiesCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.BitcoinWithdrawalOfferStatusCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	SecurityPreference{invoke.EthereumWithdrawalOfferCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumWithdrawalOfferPropertiesCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumWithdrawalOfferStatusCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	SecurityPreference{invoke.BitcoinCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.CurrencyCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumCodeCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	SecurityPreference{invoke.CryptoenterSessionCC, ping, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// clearLedger
	SecurityPreference{invoke.AccountCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.MarketaccountCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AuthCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.CommissionCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OfferCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.TransactionCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OrganizationCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserPreferenceCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.SystemPreferenceCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.DevicePreferenceCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.SessionCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.ProcessTypeCurrencyCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycUserCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycRuleCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycDocumentCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycDocumentStatusCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycRuleStatusCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumInputCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OfferStatusCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OfferPropertiesCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	SecurityPreference{invoke.BitcoinAccountOfferCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.BitcoinAccountOfferPropertiesCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.BitcoinAccountOfferStatusCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	SecurityPreference{invoke.BitcoinWithdrawalOfferCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.BitcoinWithdrawalOfferPropertiesCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.BitcoinWithdrawalOfferStatusCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	SecurityPreference{invoke.EthereumWithdrawalOfferCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumWithdrawalOfferPropertiesCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumWithdrawalOfferStatusCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	SecurityPreference{invoke.BitcoinCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.CurrencyCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumCodeCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	SecurityPreference{invoke.CryptoenterSessionCC, clearLedger, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// configure
	SecurityPreference{invoke.AccountCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.MarketaccountCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AuthCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.CommissionCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OfferCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.TransactionCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OrganizationCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserPreferenceCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.SystemPreferenceCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.DevicePreferenceCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.SessionCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.ProcessTypeCurrencyCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycUserCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycRuleCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycDocumentCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycDocumentStatusCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycRuleStatusCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumInputCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OfferStatusCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OfferPropertiesCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	SecurityPreference{invoke.BitcoinAccountOfferCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.BitcoinAccountOfferPropertiesCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.BitcoinAccountOfferStatusCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	SecurityPreference{invoke.BitcoinWithdrawalOfferCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.BitcoinWithdrawalOfferPropertiesCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.BitcoinWithdrawalOfferStatusCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	SecurityPreference{invoke.EthereumWithdrawalOfferCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumWithdrawalOfferPropertiesCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumWithdrawalOfferStatusCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	SecurityPreference{invoke.BitcoinCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.CurrencyCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumCodeCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	SecurityPreference{invoke.CryptoenterSessionCC, configure, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// AccountCC

	// invoke
	SecurityPreference{invoke.AccountCC, invoke.AddWalletFunction, ComplexParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AccountCC, invoke.AddAccountFunction, ComplexParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AccountCC, invoke.ActivateWalletFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AccountCC, invoke.BlockWalletFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AccountCC, invoke.ChangeWalletToMainType, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AccountCC, invoke.ActivateAccountFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AccountCC, invoke.BlockAccountFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AccountCC, invoke.ChangeAccountToMainType, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.AccountCC, invoke.GetAccountByCurrencyTypeFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AccountCC, invoke.VerifyUserAccountFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AccountCC, invoke.CheckAndLoadAccountFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AccountCC, invoke.GetAllUserWalletsFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AccountCC, invoke.GetAccountInfoByAccountIDFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AccountCC, invoke.GetAccountsFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AccountCC, invoke.GetWalletsFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AccountCC, invoke.GetAccountFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AccountCC, invoke.GetWalletFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// MarketaccountCC

	// invoke
	SecurityPreference{invoke.MarketaccountCC, invoke.AddWalletFunction, ComplexParameter, []Roles{UserRole}},
	SecurityPreference{invoke.MarketaccountCC, invoke.AddAccountFunction, ComplexParameter, []Roles{UserRole}},
	SecurityPreference{invoke.MarketaccountCC, invoke.ActivateWalletFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.MarketaccountCC, invoke.BlockWalletFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.MarketaccountCC, invoke.ActivateAccountFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.MarketaccountCC, invoke.BlockAccountFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.MarketaccountCC, invoke.GetAccountByCurrencyTypeFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.MarketaccountCC, invoke.VerifyUserAccountFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.MarketaccountCC, invoke.CheckAndLoadAccountFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.MarketaccountCC, invoke.GetAllUserWalletsFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.MarketaccountCC, invoke.GetAccountInfoByAccountIDFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.MarketaccountCC, invoke.GetAccountsFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.MarketaccountCC, invoke.GetWalletsFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// AuthCC

	// invoke
	SecurityPreference{invoke.AuthCC, invoke.AddAuthInfoFunction, ServiceParameter, []Roles{UserRole}},
	SecurityPreference{invoke.AuthCC, invoke.UpdateAuthInfoFunction, ServiceParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.AuthCC, invoke.GetAuthInfoFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// CommissionCC

	// invoke
	SecurityPreference{invoke.CommissionCC, invoke.AddCommissionFunction, ServiceParameter, []Roles{UserRole}},
	SecurityPreference{invoke.CommissionCC, invoke.UpdateCommissionFunction, ServiceParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.CommissionCC, invoke.GetCommissionFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// BitcoinCC

	// invoke
	SecurityPreference{invoke.BitcoinCC, invoke.AddCryptocurrenciesFunction, ServiceParameter, []Roles{UserRole}},
	SecurityPreference{invoke.BitcoinCC, invoke.ClearTransferredCryptocurrencyListFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.BitcoinCC, invoke.GetCryptocurrenciesByDaemonNameFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// EthereumCC

	// invoke
	SecurityPreference{invoke.EthereumCC, invoke.AddCryptocurrenciesFunction, ServiceParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumCC, invoke.ClearTransferredCryptocurrencyListFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.EthereumCC, invoke.GetCryptocurrenciesByDaemonNameFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// OfferCC

	// invoke
	SecurityPreference{invoke.OfferCC, invoke.AddOfferFunction, ComplexParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.OfferCC, invoke.GetOffersFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OfferCC, invoke.GetOfferRecordsFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// BitcoinAccountOfferCC

	// invoke
	SecurityPreference{invoke.BitcoinAccountOfferCC, invoke.AddOfferFunction, ComplexParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.BitcoinAccountOfferCC, invoke.GetOffersFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.BitcoinAccountOfferCC, invoke.GetOfferRecordsFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// BitcoinWithdrawalOfferCC

	// invoke
	SecurityPreference{invoke.BitcoinWithdrawalOfferCC, invoke.AddOfferFunction, ComplexParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.BitcoinWithdrawalOfferCC, invoke.GetOffersFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.BitcoinWithdrawalOfferCC, invoke.GetOfferRecordsFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},


	// EthereumWithdrawalOfferCC

	// invoke
	SecurityPreference{invoke.EthereumWithdrawalOfferCC, invoke.AddOfferFunction, ComplexParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.EthereumWithdrawalOfferCC, invoke.GetOffersFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumWithdrawalOfferCC, invoke.GetOfferRecordsFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// TransactionCC

	// invoke
	SecurityPreference{invoke.TransactionCC, invoke.TransferFunction, ComplexParameter, []Roles{UserRole}},
	SecurityPreference{invoke.TransactionCC, invoke.LockFundsOnAccountFunction, ComplexParameter, []Roles{UserRole}},
	SecurityPreference{invoke.TransactionCC, invoke.LockOutFundsOnAccountFunction, ComplexParameter, []Roles{UserRole}},
	SecurityPreference{invoke.TransactionCC, invoke.TransferFundsFunction, ServiceParameter, []Roles{UserRole}},
	SecurityPreference{invoke.TransactionCC, invoke.UnlockFundsOnAccountFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.TransactionCC, invoke.DepositFundsFunction, ServiceParameter, []Roles{UserRole}},
	SecurityPreference{invoke.TransactionCC, invoke.DepositBtcFundsFunction, ServiceParameter, []Roles{UserRole}},
	SecurityPreference{invoke.TransactionCC, invoke.DepositEthFundsFunction, ServiceParameter, []Roles{UserRole}},
	SecurityPreference{invoke.TransactionCC, invoke.LockTransferToMarketFunction, ServiceParameter, []Roles{UserRole}},
	SecurityPreference{invoke.TransactionCC, invoke.LoadMarketFoundsFunction, ServiceParameter, []Roles{UserRole}},
	SecurityPreference{invoke.TransactionCC, invoke.WithdrawalMarketFundsFunction, ServiceParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.TransactionCC, invoke.CheckExistsTransactionByListFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.TransactionCC, invoke.GetTransactionsFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.TransactionCC, invoke.FindLockAmountByOperationIdAndUserIdAndCurrencyTypeFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.TransactionCC, invoke.AccountCurrencyBalanceFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// UserCC

	// invoke
	SecurityPreference{invoke.UserCC, invoke.AddRootUserFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	/*

	SecurityPreference{invoke.UserCC, invoke.AddOrganizationRootUserFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserCC, invoke.AddSystemUserFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserCC, invoke.AddServiceUserFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserCC, invoke.AddPublicKeyFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserCC, invoke.AddUserFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserCC, invoke.RevokeUserPublicKeyFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserCC, invoke.ActivateUser, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserCC, invoke.BlockUser, UserParameter, []Roles{UserRole}},

	*/
	SecurityPreference{invoke.UserCC, invoke.AddOrganizationRootUserFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserCC, invoke.AddSystemUserFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserCC, invoke.AddServiceUserFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserCC, invoke.AddPublicKeyFunction, ServiceParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserCC, invoke.AddUserFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserCC, invoke.RevokeUserPublicKeyFunction, ServiceParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserCC, invoke.ActivateUser, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserCC, invoke.BlockUser, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.UserCC, invoke.GetUserFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserCC, invoke.VerifyUserSignatureFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// OrganizationCC

	// invoke
	SecurityPreference{invoke.OrganizationCC, invoke.AddOrganizationFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.OrganizationCC, invoke.GetOrganizationFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// SessionCC extends SystemPreferenceCC

	// invoke
	SecurityPreference{invoke.SessionCC, invoke.AddPreferenceFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.SessionCC, invoke.UpdatePreferenceFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.SessionCC, invoke.GetPreferenceFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.SessionCC, invoke.GetPreferenceArrayByKeysWithFilterFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// UserpreferenceCC

	// invoke
	SecurityPreference{invoke.UserPreferenceCC, invoke.AddPreferenceFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.UserPreferenceCC, invoke.UpdatePreferenceFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.UserPreferenceCC, invoke.GetPreferenceFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// DevicePreferenceCC extends UserPreferenceCC

	// invoke
	SecurityPreference{invoke.DevicePreferenceCC, invoke.AddPreferenceFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.DevicePreferenceCC, invoke.UpdatePreferenceFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.DevicePreferenceCC, invoke.GetPreferenceFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// SystemPreferenceCC

	// invoke
	SecurityPreference{invoke.SystemPreferenceCC, invoke.AddPreferenceFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.SystemPreferenceCC, invoke.UpdatePreferenceFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.SystemPreferenceCC, invoke.GetPreferenceFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// ProcessTypeCurrencyCC extends SystemPreferenceCC

	// invoke
	SecurityPreference{invoke.ProcessTypeCurrencyCC, invoke.AddPreferenceFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.ProcessTypeCurrencyCC, invoke.UpdatePreferenceFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.ProcessTypeCurrencyCC, invoke.GetPreferenceFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.ProcessTypeCurrencyCC, invoke.GetPreferenceArrayByKeysWithFilterFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// CurrencyCC extends SystemPreferenceCC

	// invoke
	SecurityPreference{invoke.CurrencyCC, invoke.AddPreferenceFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.CurrencyCC, invoke.UpdatePreferenceFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.CurrencyCC, invoke.GetPreferenceFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.CurrencyCC, invoke.GetPreferenceArrayByKeysWithFilterFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// KycUserCC extends SystemPreferenceCC

	// invoke
	SecurityPreference{invoke.KycUserCC, invoke.AddPreferenceFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycUserCC, invoke.UpdatePreferenceFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.KycUserCC, invoke.GetPreferenceFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycUserCC, invoke.GetPreferenceArrayByKeysWithFilterFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// KycRuleCC extends SystemPreferenceCC

	// invoke
	SecurityPreference{invoke.KycRuleCC, invoke.AddPreferenceFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycRuleCC, invoke.UpdatePreferenceFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.KycRuleCC, invoke.GetPreferenceFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycRuleCC, invoke.GetPreferenceArrayByKeysWithFilterFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// KycDocumentCC extends KeyValue

	// invoke
	SecurityPreference{invoke.KycDocumentCC, invoke.AddKeyValueFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycDocumentCC, invoke.AddKeyValueArrayFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.KycDocumentCC, invoke.GetKeyValueFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycDocumentCC, invoke.GetKeyValueArrayFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycDocumentCC, invoke.GetKeyValueArrayByKeysWithFilterFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// KycDocumentStatusCC extends KeyValue

	// invoke
	SecurityPreference{invoke.KycDocumentStatusCC, invoke.AddKeyValueFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycDocumentStatusCC, invoke.AddKeyValueArrayFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.KycDocumentStatusCC, invoke.GetKeyValueFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycDocumentStatusCC, invoke.GetKeyValueArrayFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycDocumentStatusCC, invoke.GetKeyValueArrayByKeysWithFilterFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// KycRuleStatusCC extends KeyValue

	// invoke
	SecurityPreference{invoke.KycRuleStatusCC, invoke.AddKeyValueFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycRuleStatusCC, invoke.AddKeyValueArrayFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.KycRuleStatusCC, invoke.GetKeyValueFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycRuleStatusCC, invoke.GetKeyValueArrayFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.KycRuleStatusCC, invoke.GetKeyValueArrayByKeysWithFilterFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// EthereumInputCC extends KeyValue

	// invoke
	SecurityPreference{invoke.EthereumInputCC, invoke.AddKeyValueFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumInputCC, invoke.AddKeyValueArrayFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.EthereumInputCC, invoke.GetKeyValueFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumInputCC, invoke.GetKeyValueArrayFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumInputCC, invoke.GetKeyValueArrayByKeysWithFilterFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// offerstatusCC extends KeyValue

	// invoke
	SecurityPreference{invoke.OfferStatusCC, invoke.AddKeyValueFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OfferStatusCC, invoke.AddKeyValueArrayFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.OfferStatusCC, invoke.GetKeyValueFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OfferStatusCC, invoke.GetKeyValueArrayFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OfferStatusCC, invoke.GetKeyValueArrayByKeysWithFilterFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// offerpropertiesCC extends KeyValue

	// invoke
	SecurityPreference{invoke.OfferPropertiesCC, invoke.AddKeyValueFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OfferPropertiesCC, invoke.AddKeyValueArrayFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.OfferPropertiesCC, invoke.GetKeyValueFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OfferPropertiesCC, invoke.GetKeyValueArrayFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.OfferPropertiesCC, invoke.GetKeyValueArrayByKeysWithFilterFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// BitcoinWithdrawalOfferPropertiesCC extends KeyValue

	// invoke
	SecurityPreference{invoke.BitcoinWithdrawalOfferPropertiesCC, invoke.AddKeyValueFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.BitcoinWithdrawalOfferPropertiesCC, invoke.AddKeyValueArrayFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.BitcoinWithdrawalOfferPropertiesCC, invoke.GetKeyValueFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.BitcoinWithdrawalOfferPropertiesCC, invoke.GetKeyValueArrayFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.BitcoinWithdrawalOfferPropertiesCC, invoke.GetKeyValueArrayByKeysWithFilterFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// EthereumWithdrawalOfferPropertiesCC extends KeyValue

	// invoke
	SecurityPreference{invoke.EthereumWithdrawalOfferPropertiesCC, invoke.AddKeyValueFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumWithdrawalOfferPropertiesCC, invoke.AddKeyValueArrayFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.EthereumWithdrawalOfferPropertiesCC, invoke.GetKeyValueFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumWithdrawalOfferPropertiesCC, invoke.GetKeyValueArrayFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumWithdrawalOfferPropertiesCC, invoke.GetKeyValueArrayByKeysWithFilterFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// BitcoinWithdrawalOfferStatusCC extends KeyValue

	// invoke
	SecurityPreference{invoke.BitcoinWithdrawalOfferStatusCC, invoke.AddKeyValueFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.BitcoinWithdrawalOfferStatusCC, invoke.AddKeyValueArrayFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.BitcoinWithdrawalOfferStatusCC, invoke.GetKeyValueFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.BitcoinWithdrawalOfferStatusCC, invoke.GetKeyValueArrayFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.BitcoinWithdrawalOfferStatusCC, invoke.GetKeyValueArrayByKeysWithFilterFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// EthereumWithdrawalOfferStatusCC extends KeyValue

	// invoke
	SecurityPreference{invoke.EthereumWithdrawalOfferStatusCC, invoke.AddKeyValueFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumWithdrawalOfferStatusCC, invoke.AddKeyValueArrayFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.EthereumWithdrawalOfferStatusCC, invoke.GetKeyValueFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumWithdrawalOfferStatusCC, invoke.GetKeyValueArrayFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumWithdrawalOfferStatusCC, invoke.GetKeyValueArrayByKeysWithFilterFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// BitcoinAccountOfferPropertiesCC extends KeyValue

	// invoke
	SecurityPreference{invoke.BitcoinAccountOfferPropertiesCC, invoke.AddKeyValueFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.BitcoinAccountOfferPropertiesCC, invoke.AddKeyValueArrayFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.BitcoinAccountOfferPropertiesCC, invoke.GetKeyValueFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.BitcoinAccountOfferPropertiesCC, invoke.GetKeyValueArrayFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.BitcoinAccountOfferPropertiesCC, invoke.GetKeyValueArrayByKeysWithFilterFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// BitcoinAccountOfferStatusCC extends KeyValue

	// invoke
	SecurityPreference{invoke.BitcoinAccountOfferStatusCC, invoke.AddKeyValueFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.BitcoinAccountOfferStatusCC, invoke.AddKeyValueArrayFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.BitcoinAccountOfferStatusCC, invoke.GetKeyValueFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.BitcoinAccountOfferStatusCC, invoke.GetKeyValueArrayFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.BitcoinAccountOfferStatusCC, invoke.GetKeyValueArrayByKeysWithFilterFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},// BitcoinAccountOfferStatusCC extends KeyValue

	// cryptoentersessionCC extends KeyValue

	// invoke
	SecurityPreference{invoke.CryptoenterSessionCC, invoke.AddKeyValueFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.CryptoenterSessionCC, invoke.AddKeyValueArrayFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.CryptoenterSessionCC, invoke.GetKeyValueFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.CryptoenterSessionCC, invoke.GetKeyValueArrayFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.CryptoenterSessionCC, invoke.GetKeyValueArrayByKeysWithFilterFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

	// ethereumcodeCC extends ethereumcodeCC extends KeyValue

	// invoke
	// from ethereumcodeCC
	SecurityPreference{invoke.EthereumCodeCC, invoke.AddCodeFunction, ComplexParameter, []Roles{UserRole}},
	// from KeyValue
	SecurityPreference{invoke.EthereumCodeCC, invoke.AddKeyValueFunction, UserParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumCodeCC, invoke.AddKeyValueArrayFunction, UserParameter, []Roles{UserRole}},
	// query
	SecurityPreference{invoke.EthereumCodeCC, invoke.GetKeyValueFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumCodeCC, invoke.GetKeyValueArrayFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},
	SecurityPreference{invoke.EthereumCodeCC, invoke.GetKeyValueArrayByKeysWithFilterFunction, ServiceParameter | UnsecuredParameter, []Roles{UserRole}},

}
